﻿using System.Collections.Generic;
using NTERA.Engine.Compiler;

namespace NTERA.Engine.Runtime
{
	public interface IExecutionProvider
	{
		ICollection<FunctionDefinition> DefinedProcedures { get; }
		ICollection<FunctionDefinition> DefinedFunctions { get; }
		ICollection<FunctionVariable> DefinedConstants { get; }
		CSVDefinition CSVDefinition { get; }

		IEnumerable<ExecutionNode> GetExecutionNodes(FunctionDefinition function);
	}
}